// Written by Gunnar Lindholm.
// License GPL v2.
#include "function.h"
#include <iostream>
using namespace std;

POLY::POLY(){
	grad = 1;
	koef.clear();
	koef.push_back(2);
	koef.push_back(-3);
	low=-2;
	high=2;
}

void POLY::print(){
	if (koef[0]!=0)
		cout<<koef[0];
	if (grad>0)
		if(koef[1]>0)
			cout<<" + "<<koef[1]<<"x";
		else if (koef[1]<0)
			cout<<" - "<<-koef[1]<<"x";
	for (int i=2;i<=grad;i++)
		if(koef[i]>0)
			cout<<" + "<<koef[i]<<"x^"<<i;
		else if (koef[i]<0)
			cout<<" - "<<-koef[i]<<"x^"<<i;
}

void POLY::define(){
	cout<<"\n\nAnge gradtalet i polynom (heltal): ";
	koef.clear();
	cin>>grad;
	cout<<"Ange koefficienterna i polynomet, ange dem i vxande gradal :\n";
	cout<<"    T.ex.  3  0  1.5   fr  3+1,5x^2    OBS! punkt istlletfr ,\n";
	cout<<"koeff: ";
	double x;
	for (int i=0;i<=grad;i++){
		cin>>x;
		koef.push_back(x);
	}
}

double POLY::value(double x){
	double pot=1.0,sum=0;
	sum=0;
	for (int i=0;i<koef.size();i++){
		sum=sum + pot * koef[i];
		pot = pot*x;
	}
	return sum;
}

// I'll use the derivative in the next verison...
void POLY::find_minmax(double& max, double& min){
	double x,y;
	max=-1e99;
	min=1e99;
	for (x=low;x<=high;x+=0.1){
		y=value(x);
		if (y>max)
			max=y;
		else if (y<min)
			min=y;
	}
}
