// Written by Gunanr Lindholm
// License GPLv2
#ifndef _graf_h_
#define _graf_h_
#include <string>
#include "function.h"
using namespace std;
class Graf{
public:
	Graf();
	void draw(); //draws to filename, function poly

private:
	POLY poly;
	string filename;
	
	double bbxlow,bbylow,bbxhigh,bbyhigh; //boundingbox
	double unitlength;
	string unitlengthunit;
	
	double pictureX,pictureY;
	double offsetX,offsetY;
	double gridstepX,gridstepY; // grid is bb(x|y)low: gridstep(x|y): bb(x|y)high
//	double EPS; // this is 0.01 and is somewhat the accuracy for simple stuff
//	double EPSHIGH; // accuracy for high precision, 0.00000...00001

	double coordstepX,coordstepY; // steps in print coord on axis.
	// draws coordinates on axis.
	string v_axiscoord(double value);
	string h_axiscoord(double value);
	double X(double value);  // transformas to latex coordinates.
	double Y(double value);
	double stepsize; // stepsize for plotting
	bool leftclosed,rightclosed;
	bool markend; // mark end of intervall
};
#endif
